# Do not modify this file by hand.
#
# It is automatically generated by src/api_wrappers/generateRAPIWrappers.py.
# (Run make api_wrappers to update it.)

##' analysisAddTags API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-analysis-xxxx-addtags}
analysisAddTags <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' analysisDescribe API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-analysis-xxxx-describe}
analysisDescribe <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' analysisRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-analysis-xxxx-removetags}
analysisRemoveTags <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' analysisSetProperties API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-analysis-xxxx-setproperties}
analysisSetProperties <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' analysisTerminate API wrapper
##'
##' This function makes an API call to the \code{/analysis-xxxx/terminate} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-analysis-xxxx-terminate}
analysisTerminate <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'terminate', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appAddAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/addAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-addauthorizedusers}
appAddAuthorizedUsers <- function(appNameOrID, alias=NULL,
                                  inputParams=emptyNamedList, jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'addAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appAddCategories API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/addCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-addcategories}
appAddCategories <- function(appNameOrID, alias=NULL,
                             inputParams=emptyNamedList, jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'addCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appAddDevelopers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/addDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-adddevelopers}
appAddDevelopers <- function(appNameOrID, alias=NULL,
                             inputParams=emptyNamedList, jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'addDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appAddTags API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-addtags}
appAddTags <- function(appNameOrID, alias=NULL,
                       inputParams=emptyNamedList, jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appDelete API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/delete} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-delete}
appDelete <- function(appNameOrID, alias=NULL,
                      inputParams=emptyNamedList, jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'delete', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appDescribe API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-describe}
appDescribe <- function(appNameOrID, alias=NULL,
                        inputParams=emptyNamedList, jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appGet API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/get} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-get}
appGet <- function(appNameOrID, alias=NULL,
                   inputParams=emptyNamedList, jsonifyData=TRUE,
                   alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'get', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appInstall API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/install} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-install}
appInstall <- function(appNameOrID, alias=NULL,
                       inputParams=emptyNamedList, jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'install', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appListAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/listAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-listauthorizedusers}
appListAuthorizedUsers <- function(appNameOrID, alias=NULL,
                                   inputParams=emptyNamedList, jsonifyData=TRUE,
                                   alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'listAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appListCategories API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/listCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-listcategories}
appListCategories <- function(appNameOrID, alias=NULL,
                              inputParams=emptyNamedList, jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'listCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appListDevelopers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/listDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-listdevelopers}
appListDevelopers <- function(appNameOrID, alias=NULL,
                              inputParams=emptyNamedList, jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'listDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appPublish API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/publish} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-publish}
appPublish <- function(appNameOrID, alias=NULL,
                       inputParams=emptyNamedList, jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'publish', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRemoveAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/removeAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-removeauthorizedusers}
appRemoveAuthorizedUsers <- function(appNameOrID, alias=NULL,
                                     inputParams=emptyNamedList, jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'removeAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRemoveCategories API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/removeCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-removecategories}
appRemoveCategories <- function(appNameOrID, alias=NULL,
                                inputParams=emptyNamedList, jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'removeCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRemoveDevelopers API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/removeDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-removedevelopers}
appRemoveDevelopers <- function(appNameOrID, alias=NULL,
                                inputParams=emptyNamedList, jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'removeDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-removetags}
appRemoveTags <- function(appNameOrID, alias=NULL,
                          inputParams=emptyNamedList, jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appRun API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/run} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-run}
appRun <- function(appNameOrID, alias=NULL,
                   inputParams=emptyNamedList, jsonifyData=TRUE,
                   alwaysRetry=FALSE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'run', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appValidateBatch API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/validateBatch} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-validatebatch}
appValidateBatch <- function(appNameOrID, alias=NULL,
                             inputParams=emptyNamedList, jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'validateBatch', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appUninstall API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/uninstall} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-uninstall}
appUninstall <- function(appNameOrID, alias=NULL,
                         inputParams=emptyNamedList, jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'uninstall', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appUpdate API wrapper
##'
##' This function makes an API call to the \code{/app-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param appNameOrID An app identifier using either the name of an app
##' ("app-name") or its full ID ("app-xxxx")
##' @param alias If an app name is given for \code{appNameOrID}, this can be
##' provided to specify a version or tag (if not provided, the "default" tag is
##' used).
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-xxxx-yyyy-update}
appUpdate <- function(appNameOrID, alias=NULL,
                      inputParams=emptyNamedList, jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  if (is.null(alias)) {
    fullyQualifiedVersion <- paste('/', appNameOrID, sep='')
  } else {
    fullyQualifiedVersion <- paste('/', appNameOrID, '/', alias, sep='')
  }
  resource <- paste(fullyQualifiedVersion, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appNew API wrapper
##'
##' This function makes an API call to the \code{/app/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/apps#api-method-app-new}
appNew <- function(inputParams=emptyNamedList,
                   jsonifyData=TRUE,
                   alwaysRetry=FALSE) {
  dxHTTPRequest('/app/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' appletAddTags API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-addtags}
appletAddTags <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletDescribe API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-applet-xxxx-describe}
appletDescribe <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletGet API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/get} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-applet-xxxx-get}
appletGet <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'get', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletGetDetails API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-getdetails}
appletGetDetails <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletListProjects API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/cloning#api-method-class-xxxx-listprojects}
appletListProjects <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-removetags}
appletRemoveTags <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletRename API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/name#api-method-class-xxxx-rename}
appletRename <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletValidateBatch API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/validateBatch} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-applet-xxxx-validatebatch}
appletValidateBatch <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'validateBatch', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletRun API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/run} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-applet-xxxx-run}
appletRun <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'run', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletSetProperties API wrapper
##'
##' This function makes an API call to the \code{/applet-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/properties#api-method-class-xxxx-setproperties}
appletSetProperties <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' appletNew API wrapper
##'
##' This function makes an API call to the \code{/applet/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-applet-new}
appletNew <- function(inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=FALSE) {
  dxHTTPRequest('/applet/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' containerClone API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/clone} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/cloning#api-method-class-xxxx-clone}
containerClone <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'clone', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerDescribe API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/containers-for-execution#api-method-container-xxxx-describe}
containerDescribe <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerDestroy API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/destroy} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
containerDestroy <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'destroy', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerListFolder API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/listFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-listfolder}
containerListFolder <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerMove API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/move} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-move}
containerMove <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'move', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerNewFolder API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/newFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-newfolder}
containerNewFolder <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'newFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerRemoveFolder API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/removeFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-removefolder}
containerRemoveFolder <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'removeFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerRemoveObjects API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/removeObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-removeobjects}
containerRemoveObjects <- function(objectID,
                                   inputParams=emptyNamedList,
                                   jsonifyData=TRUE,
                                   alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'removeObjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' containerRenameFolder API wrapper
##'
##' This function makes an API call to the \code{/container-xxxx/renameFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-renamefolder}
containerRenameFolder <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'renameFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseAddTags API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-addtags}
databaseAddTags <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseAddTypes API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/addTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/types#api-method-class-xxxx-addtypes}
databaseAddTypes <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseClose API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/close} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle#api-method-class-xxxx-close}
databaseClose <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'close', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseDescribe API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/databases#api-method-database-xxxx-describe}
databaseDescribe <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseGetDetails API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-getdetails}
databaseGetDetails <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseListProjects API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/cloning#api-method-class-xxxx-listprojects}
databaseListProjects <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseRelocate API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/relocate} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/databases#api-method-database-xxxx-relocate}
databaseRelocate <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'relocate', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-removetags}
databaseRemoveTags <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseRemoveTypes API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/removeTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/types#api-method-class-xxxx-removetypes}
databaseRemoveTypes <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseRename API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/name#api-method-class-xxxx-rename}
databaseRename <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseSetDetails API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/setDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-setdetails}
databaseSetDetails <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseSetProperties API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/properties#api-method-class-xxxx-setproperties}
databaseSetProperties <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseSetVisibility API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/setVisibility} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/visibility#api-method-class-xxxx-setvisibility}
databaseSetVisibility <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setVisibility', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseDownloadFile API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/downloadFile} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{}
databaseDownloadFile <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'downloadFile', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' databaseListFolder API wrapper
##'
##' This function makes an API call to the \code{/database-xxxx/listFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-listfolder}
databaseListFolder <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileAddTags API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-addtags}
fileAddTags <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileAddTypes API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/addTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/types#api-method-class-xxxx-addtypes}
fileAddTypes <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileClose API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/close} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/files#api-method-file-xxxx-close}
fileClose <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'close', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileDescribe API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/files#api-method-file-xxxx-describe}
fileDescribe <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileDownload API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/download} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/files#api-method-file-xxxx-download}
fileDownload <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'download', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileGetDetails API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-getdetails}
fileGetDetails <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileListProjects API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/cloning#api-method-class-xxxx-listprojects}
fileListProjects <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-removetags}
fileRemoveTags <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileRemoveTypes API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/removeTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/types#api-method-class-xxxx-removetypes}
fileRemoveTypes <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileRename API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/name#api-method-class-xxxx-rename}
fileRename <- function(objectID,
                       inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileSetDetails API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/setDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-setdetails}
fileSetDetails <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileSetProperties API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/properties#api-method-class-xxxx-setproperties}
fileSetProperties <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileSetVisibility API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/setVisibility} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/visibility#api-method-class-xxxx-setvisibility}
fileSetVisibility <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setVisibility', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileUpload API wrapper
##'
##' This function makes an API call to the \code{/file-xxxx/upload} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/files#api-method-file-xxxx-upload}
fileUpload <- function(objectID,
                       inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'upload', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' fileNew API wrapper
##'
##' This function makes an API call to the \code{/file/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/files#api-method-file-new}
fileNew <- function(inputParams=emptyNamedList,
                    jsonifyData=TRUE,
                    alwaysRetry=FALSE) {
  dxHTTPRequest('/file/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' globalWorkflowAddAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/addAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-addauthorizedusers}
globalWorkflowAddAuthorizedUsers <- function(objectID,
                                             inputParams=emptyNamedList,
                                             jsonifyData=TRUE,
                                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowAddCategories API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/addCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-addcategories}
globalWorkflowAddCategories <- function(objectID,
                                        inputParams=emptyNamedList,
                                        jsonifyData=TRUE,
                                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowAddDevelopers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/addDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-adddevelopers}
globalWorkflowAddDevelopers <- function(objectID,
                                        inputParams=emptyNamedList,
                                        jsonifyData=TRUE,
                                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowAddTags API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-addtags}
globalWorkflowAddTags <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowDelete API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/delete} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-delete}
globalWorkflowDelete <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'delete', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowDescribe API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-describe}
globalWorkflowDescribe <- function(objectID,
                                   inputParams=emptyNamedList,
                                   jsonifyData=TRUE,
                                   alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowListAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/listAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-listauthorizedusers}
globalWorkflowListAuthorizedUsers <- function(objectID,
                                              inputParams=emptyNamedList,
                                              jsonifyData=TRUE,
                                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowListCategories API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/listCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-listcategories}
globalWorkflowListCategories <- function(objectID,
                                         inputParams=emptyNamedList,
                                         jsonifyData=TRUE,
                                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowListDevelopers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/listDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-listdevelopers}
globalWorkflowListDevelopers <- function(objectID,
                                         inputParams=emptyNamedList,
                                         jsonifyData=TRUE,
                                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowPublish API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/publish} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-publish}
globalWorkflowPublish <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'publish', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRemoveAuthorizedUsers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/removeAuthorizedUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-removeauthorizedusers}
globalWorkflowRemoveAuthorizedUsers <- function(objectID,
                                                inputParams=emptyNamedList,
                                                jsonifyData=TRUE,
                                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeAuthorizedUsers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRemoveCategories API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/removeCategories} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-removecategories}
globalWorkflowRemoveCategories <- function(objectID,
                                           inputParams=emptyNamedList,
                                           jsonifyData=TRUE,
                                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeCategories', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRemoveDevelopers API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/removeDevelopers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-removedevelopers}
globalWorkflowRemoveDevelopers <- function(objectID,
                                           inputParams=emptyNamedList,
                                           jsonifyData=TRUE,
                                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeDevelopers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-removetags}
globalWorkflowRemoveTags <- function(objectID,
                                     inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowRun API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/run} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-run}
globalWorkflowRun <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'run', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowUpdate API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-xxxx-yyyy-update}
globalWorkflowUpdate <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' globalWorkflowNew API wrapper
##'
##' This function makes an API call to the \code{/globalworkflow/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/global-workflows#api-method-globalworkflow-new}
globalWorkflowNew <- function(inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=FALSE) {
  dxHTTPRequest('/globalworkflow/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' jobAddTags API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-job-xxxx-addtags}
jobAddTags <- function(objectID,
                       inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobDescribe API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-job-xxxx-describe}
jobDescribe <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobGetLog API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/getLog} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-job-xxxx-getlog}
jobGetLog <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'getLog', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-job-xxxx-removetags}
jobRemoveTags <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobSetProperties API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-job-xxxx-setproperties}
jobSetProperties <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobTerminate API wrapper
##'
##' This function makes an API call to the \code{/job-xxxx/terminate} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-job-xxxx-terminate}
jobTerminate <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'terminate', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' jobNew API wrapper
##'
##' This function makes an API call to the \code{/job/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/applets-and-entry-points#api-method-job-new}
jobNew <- function(inputParams=emptyNamedList,
                   jsonifyData=TRUE,
                   alwaysRetry=FALSE) {
  dxHTTPRequest('/job/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' notificationsGet API wrapper
##'
##' This function makes an API call to the \code{/notifications/get} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
notificationsGet <- function(inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  dxHTTPRequest('/notifications/get', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' notificationsMarkRead API wrapper
##'
##' This function makes an API call to the \code{/notifications/markRead} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
notificationsMarkRead <- function(inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  dxHTTPRequest('/notifications/markRead', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' orgDescribe API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-xxxx-describe}
orgDescribe <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgFindMembers API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/findMembers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-xxxx-findmembers}
orgFindMembers <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'findMembers', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgFindProjects API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/findProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-xxxx-findprojects}
orgFindProjects <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'findProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgFindApps API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/findApps} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-xxxx-findapps}
orgFindApps <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'findApps', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgInvite API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/invite} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-xxxx-invite}
orgInvite <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'invite', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgRemoveMember API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/removeMember} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-xxxx-removemember}
orgRemoveMember <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeMember', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgSetMemberAccess API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/setMemberAccess} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-xxxx-setmemberaccess}
orgSetMemberAccess <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setMemberAccess', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgUpdate API wrapper
##'
##' This function makes an API call to the \code{/org-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-xxxx-update}
orgUpdate <- function(objectID,
                      inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' orgNew API wrapper
##'
##' This function makes an API call to the \code{/org/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/organizations#api-method-org-new}
orgNew <- function(inputParams=emptyNamedList,
                   jsonifyData=TRUE,
                   alwaysRetry=FALSE) {
  dxHTTPRequest('/org/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' projectAddTags API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/projects#api-method-project-xxxx-addtags}
projectAddTags <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectClone API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/clone} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/cloning#api-method-class-xxxx-clone}
projectClone <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'clone', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectDecreasePermissions API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/decreasePermissions} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/project-permissions-and-sharing#api-method-project-xxxx-decreasepermissions}
projectDecreasePermissions <- function(objectID,
                                       inputParams=emptyNamedList,
                                       jsonifyData=TRUE,
                                       alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'decreasePermissions', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectDescribe API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/projects#api-method-project-xxxx-describe}
projectDescribe <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectDestroy API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/destroy} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/projects#api-method-project-xxxx-destroy}
projectDestroy <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'destroy', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectInvite API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/invite} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/project-permissions-and-sharing#api-method-project-xxxx-invite}
projectInvite <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'invite', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectLeave API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/leave} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/project-permissions-and-sharing#api-method-project-xxxx-leave}
projectLeave <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'leave', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectListFolder API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/listFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-listfolder}
projectListFolder <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectMove API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/move} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-move}
projectMove <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'move', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectNewFolder API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/newFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-newfolder}
projectNewFolder <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'newFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectRemoveFolder API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/removeFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-removefolder}
projectRemoveFolder <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'removeFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectRemoveObjects API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/removeObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-removeobjects}
projectRemoveObjects <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'removeObjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/projects#api-method-project-xxxx-removetags}
projectRemoveTags <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectRenameFolder API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/renameFolder} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/folders-and-deletion#api-method-class-xxxx-renamefolder}
projectRenameFolder <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'renameFolder', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectSetProperties API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/projects#api-method-project-xxxx-setproperties}
projectSetProperties <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectTransfer API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/transfer} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/project-permissions-and-sharing#api-method-project-xxxx-transfer}
projectTransfer <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'transfer', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectUpdate API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/projects#api-method-project-xxxx-update}
projectUpdate <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectUpdateSponsorship API wrapper
##'
##' This function makes an API call to the \code{/project-xxxx/updateSponsorship} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/projects#api-method-project-xxxx-updatesponsorship}
projectUpdateSponsorship <- function(objectID,
                                     inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'updateSponsorship', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' projectNew API wrapper
##'
##' This function makes an API call to the \code{/project/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/projects#api-method-project-new}
projectNew <- function(inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=FALSE) {
  dxHTTPRequest('/project/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' recordAddTags API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-addtags}
recordAddTags <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordAddTypes API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/addTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/types#api-method-class-xxxx-addtypes}
recordAddTypes <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordClose API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/close} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle#api-method-class-xxxx-close}
recordClose <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'close', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordDescribe API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/records#api-method-record-xxxx-describe}
recordDescribe <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordGetDetails API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-getdetails}
recordGetDetails <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordListProjects API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/cloning#api-method-class-xxxx-listprojects}
recordListProjects <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-removetags}
recordRemoveTags <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordRemoveTypes API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/removeTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/types#api-method-class-xxxx-removetypes}
recordRemoveTypes <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordRename API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/name#api-method-class-xxxx-rename}
recordRename <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordSetDetails API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/setDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-setdetails}
recordSetDetails <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordSetProperties API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/properties#api-method-class-xxxx-setproperties}
recordSetProperties <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordSetVisibility API wrapper
##'
##' This function makes an API call to the \code{/record-xxxx/setVisibility} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/visibility#api-method-class-xxxx-setvisibility}
recordSetVisibility <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setVisibility', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' recordNew API wrapper
##'
##' This function makes an API call to the \code{/record/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-classes/records#api-method-record-new}
recordNew <- function(inputParams=emptyNamedList,
                      jsonifyData=TRUE,
                      alwaysRetry=FALSE) {
  dxHTTPRequest('/record/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemDescribeDataObjects API wrapper
##'
##' This function makes an API call to the \code{/system/describeDataObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/system-methods#api-method-system-describedataobjects}
systemDescribeDataObjects <- function(inputParams=emptyNamedList,
                                      jsonifyData=TRUE,
                                      alwaysRetry=TRUE) {
  dxHTTPRequest('/system/describeDataObjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemDescribeExecutions API wrapper
##'
##' This function makes an API call to the \code{/system/describeExecutions} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/system-methods#api-method-system-describeexecutions}
systemDescribeExecutions <- function(inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  dxHTTPRequest('/system/describeExecutions', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemDescribeProjects API wrapper
##'
##' This function makes an API call to the \code{/system/describeProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/system-methods#api-method-system-describeprojects}
systemDescribeProjects <- function(inputParams=emptyNamedList,
                                   jsonifyData=TRUE,
                                   alwaysRetry=TRUE) {
  dxHTTPRequest('/system/describeProjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindAffiliates API wrapper
##'
##' This function makes an API call to the \code{/system/findAffiliates} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemFindAffiliates <- function(inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findAffiliates', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindApps API wrapper
##'
##' This function makes an API call to the \code{/system/findApps} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-findapps}
systemFindApps <- function(inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findApps', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindDataObjects API wrapper
##'
##' This function makes an API call to the \code{/system/findDataObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-finddataobjects}
systemFindDataObjects <- function(inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findDataObjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindGlobalWorkflows API wrapper
##'
##' This function makes an API call to the \code{/system/findGlobalWorkflows} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemFindGlobalWorkflows <- function(inputParams=emptyNamedList,
                                      jsonifyData=TRUE,
                                      alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findGlobalWorkflows', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemResolveDataObjects API wrapper
##'
##' This function makes an API call to the \code{/system/resolveDataObjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/system-methods#api-method-system-resolvedataobjects}
systemResolveDataObjects <- function(inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  dxHTTPRequest('/system/resolveDataObjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindExecutions API wrapper
##'
##' This function makes an API call to the \code{/system/findExecutions} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-findexecutions}
systemFindExecutions <- function(inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findExecutions', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindAnalyses API wrapper
##'
##' This function makes an API call to the \code{/system/findAnalyses} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-findanalyses}
systemFindAnalyses <- function(inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findAnalyses', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindDatabases API wrapper
##'
##' This function makes an API call to the \code{/system/findDatabases} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-finddatabases}
systemFindDatabases <- function(inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findDatabases', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindJobs API wrapper
##'
##' This function makes an API call to the \code{/system/findJobs} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-findjobs}
systemFindJobs <- function(inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findJobs', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindProjects API wrapper
##'
##' This function makes an API call to the \code{/system/findProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-findprojects}
systemFindProjects <- function(inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findProjects', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindUsers API wrapper
##'
##' This function makes an API call to the \code{/system/findUsers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemFindUsers <- function(inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findUsers', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindProjectMembers API wrapper
##'
##' This function makes an API call to the \code{/system/findProjectMembers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-findprojectmembers}
systemFindProjectMembers <- function(inputParams=emptyNamedList,
                                     jsonifyData=TRUE,
                                     alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findProjectMembers', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemFindOrgs API wrapper
##'
##' This function makes an API call to the \code{/system/findOrgs} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/search#api-method-system-findorgs}
systemFindOrgs <- function(inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  dxHTTPRequest('/system/findOrgs', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemGenerateBatchInputs API wrapper
##'
##' This function makes an API call to the \code{/system/generateBatchInputs} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/system-methods#api-method-system-generatebatchinputs}
systemGenerateBatchInputs <- function(inputParams=emptyNamedList,
                                      jsonifyData=TRUE,
                                      alwaysRetry=TRUE) {
  dxHTTPRequest('/system/generateBatchInputs', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemGlobalSearch API wrapper
##'
##' This function makes an API call to the \code{/system/globalSearch} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemGlobalSearch <- function(inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  dxHTTPRequest('/system/globalSearch', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemGreet API wrapper
##'
##' This function makes an API call to the \code{/system/greet} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemGreet <- function(inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=TRUE) {
  dxHTTPRequest('/system/greet', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemHeaders API wrapper
##'
##' This function makes an API call to the \code{/system/headers} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemHeaders <- function(inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  dxHTTPRequest('/system/headers', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemShortenURL API wrapper
##'
##' This function makes an API call to the \code{/system/shortenURL} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
systemShortenURL <- function(inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  dxHTTPRequest('/system/shortenURL', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' systemWhoami API wrapper
##'
##' This function makes an API call to the \code{/system/whoami} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/system-methods#api-method-system-whoamiwiki.}
systemWhoami <- function(inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  dxHTTPRequest('/system/whoami', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}

##' userDescribe API wrapper
##'
##' This function makes an API call to the \code{/user-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/users#api-method-user-xxxx-describe}
userDescribe <- function(objectID,
                         inputParams=emptyNamedList,
                         jsonifyData=TRUE,
                         alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' userUpdate API wrapper
##'
##' This function makes an API call to the \code{/user-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/users#api-method-user-xxxx-update}
userUpdate <- function(objectID,
                       inputParams=emptyNamedList,
                       jsonifyData=TRUE,
                       alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowAddStage API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/addStage} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-addstage}
workflowAddStage <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addStage', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowAddTags API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/addTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-addtags}
workflowAddTags <- function(objectID,
                            inputParams=emptyNamedList,
                            jsonifyData=TRUE,
                            alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowAddTypes API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/addTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/types#api-method-class-xxxx-addtypes}
workflowAddTypes <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'addTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowClose API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/close} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle#api-method-class-xxxx-close}
workflowClose <- function(objectID,
                          inputParams=emptyNamedList,
                          jsonifyData=TRUE,
                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'close', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowDescribe API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/describe} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-describe}
workflowDescribe <- function(objectID,
                             inputParams=emptyNamedList,
                             jsonifyData=TRUE,
                             alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'describe', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowDryRun API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/dryRun} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-dryrun}
workflowDryRun <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'dryRun', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowGetDetails API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/getDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-getdetails}
workflowGetDetails <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'getDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowIsStageCompatible API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/isStageCompatible} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-isstagecompatible}
workflowIsStageCompatible <- function(objectID,
                                      inputParams=emptyNamedList,
                                      jsonifyData=TRUE,
                                      alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'isStageCompatible', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowListProjects API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/listProjects} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-containers/cloning#api-method-class-xxxx-listprojects}
workflowListProjects <- function(objectID,
                                 inputParams=emptyNamedList,
                                 jsonifyData=TRUE,
                                 alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'listProjects', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowMoveStage API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/moveStage} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-movestage}
workflowMoveStage <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'moveStage', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowOverwrite API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/overwrite} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-overwrite}
workflowOverwrite <- function(objectID,
                              inputParams=emptyNamedList,
                              jsonifyData=TRUE,
                              alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'overwrite', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRemoveStage API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/removeStage} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-removestage}
workflowRemoveStage <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeStage', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRemoveTags API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/removeTags} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/tags#api-method-class-xxxx-removetags}
workflowRemoveTags <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTags', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRemoveTypes API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/removeTypes} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/types#api-method-class-xxxx-removetypes}
workflowRemoveTypes <- function(objectID,
                                inputParams=emptyNamedList,
                                jsonifyData=TRUE,
                                alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'removeTypes', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRename API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/rename} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/name#api-method-class-xxxx-rename}
workflowRename <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'rename', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowRun API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/run} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-run}
workflowRun <- function(objectID,
                        inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=FALSE) {
  resource <- paste('/', objectID, '/', 'run', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowValidateBatch API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/validateBatch} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-validatebatch}
workflowValidateBatch <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'validateBatch', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowSetDetails API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/setDetails} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/details-and-links#api-method-class-xxxx-setdetails}
workflowSetDetails <- function(objectID,
                               inputParams=emptyNamedList,
                               jsonifyData=TRUE,
                               alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setDetails', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowSetProperties API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/setProperties} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/introduction-to-data-object-metadata/properties#api-method-class-xxxx-setproperties}
workflowSetProperties <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setProperties', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowSetVisibility API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/setVisibility} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/data-object-lifecycle/visibility#api-method-class-xxxx-setvisibility}
workflowSetVisibility <- function(objectID,
                                  inputParams=emptyNamedList,
                                  jsonifyData=TRUE,
                                  alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'setVisibility', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowUpdate API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/update} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-update}
workflowUpdate <- function(objectID,
                           inputParams=emptyNamedList,
                           jsonifyData=TRUE,
                           alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'update', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowUpdateStageExecutable API wrapper
##'
##' This function makes an API call to the \code{/workflow-xxxx/updateStageExecutable} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param objectID DNAnexus object ID
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-xxxx-updatestageexecutable}
workflowUpdateStageExecutable <- function(objectID,
                                          inputParams=emptyNamedList,
                                          jsonifyData=TRUE,
                                          alwaysRetry=TRUE) {
  resource <- paste('/', objectID, '/', 'updateStageExecutable', sep='')
  dxHTTPRequest(resource,
                inputParams,
                jsonifyData=jsonifyData,
                alwaysRetry=alwaysRetry)
}

##' workflowNew API wrapper
##'
##' This function makes an API call to the \code{/workflow/new} API
##' method; it is a simple wrapper around the \code{\link{dxHTTPRequest}}
##' function which makes POST HTTP requests to the API server.
##'
##' 
##' @param inputParams Either an R object that will be converted into JSON
##' using \code{RJSONIO::toJSON} to be used as the input to the API call.  If
##' providing the JSON string directly, you must set \code{jsonifyData} to
##' \code{FALSE}.
##' @param jsonifyData Whether to call \code{RJSONIO::toJSON} on
##' \code{inputParams} to create the JSON string or pass through the value of
##' \code{inputParams} directly.  (Default is \code{TRUE}.)
##' @param alwaysRetry Whether to always retry even when no response is
##' received from the API server
##' @return If the API call is successful, the parsed JSON of the API server
##' response is returned (using \code{RJSONIO::fromJSON}).
##' @export
##' @seealso \code{\link{dxHTTPRequest}}
##' @references API spec documentation: \url{https://documentation.dnanexus.com/developer/api/running-analyses/workflows-and-analyses#api-method-workflow-new}
workflowNew <- function(inputParams=emptyNamedList,
                        jsonifyData=TRUE,
                        alwaysRetry=FALSE) {
  dxHTTPRequest('/workflow/new', inputParams, jsonifyData=jsonifyData, alwaysRetry=alwaysRetry)
}
